;===============================================================================
;
; alternative atma weapon 1.0b
;
; - change the damage algorithm of the atma weapon
;
;===============================================================================
header
hirom

;===============================================================================
;
; damage algorithms
;
;===============================================================================
org     $C20E39

;-------------------------------------------------------------------------------
; null old damage algorithm
;-------------------------------------------------------------------------------
    ;exit
        RTS

;-------------------------------------------------------------------------------
; setup new damage algorithm
;-------------------------------------------------------------------------------
atma_weapon_effect:

    ;init
        PHX                 ;backup X
        PHP                 ;backup status
        LDX #$5A            ;base weapon animation
        REP #$20            ;mode C

    ;setup new damage
        LDA $3BF4,Y         ;actual hp
        STA $11B0           ;save as damage

    ;check max lenght animation
        LDA $3C1C,Y         ;max hp
        CMP $11B0           ;actual hp
        BEQ .anim_high      ;setup full animation

    ;check medium lenght animation
        LSR                 ;C = max hp / 2
        CMP $11B0           ;actual hp
        BCC .anim_med       ;setup medium animation

    ;setup low lenght animation
        BRA .anim_low

    ;setup animations
.anim_high
        INX
.anim_med
        INX
        STX $B7             ;save animation
.anim_low

    ;setup attack flags
        STZ $3414           ;avoid damage randomness
        LDA #$20            ;ignore defense
        TSB $11A2           ;setup flag

    ;exit
        PLP                 ;restore status
        PLX                 ;restore X
        RTS

warnpc  $C20E77

;===============================================================================
;
; redirect atma weapon special effect
;
;===============================================================================
org     $C24044

    ;redirection
        JMP atma_weapon_effect

warnpc  $C2404E

